IMPLEMENTATION MODULE Urs;
FROM MATHLIB IMPORT Exp,Log,Sin,Cos;
FROM Maths IMPORT Sign,Xi,Imp,War,Dict;

CONST
    LimT = 600.;
TYPE
   ArrLT = ARRAY SHORTCARD[1..10] OF LongType;
   ArrALT = ARRAY SHORTCARD[1..10],SHORTCARD[1..10] OF LongType;
VAR Eths: SHORTCARD;
VAR Nn,n0,
    KPii,KPpp,KPm,KPsp,KPsm,KPo,KPe,KPpm,KPl,KPc,
    KSii,KMii,KMo,KMl,KMp,KOm,KOt1,KOt2,KOc1,KOc2,
    KLo,KLc: ArrLT;
    KPw,KPt,KSw,KMt,KMc,KMw,KOwop,KOwom,KCc: ArrALT;

  PROCEDURE ConvertEthnos(bd: BDEth);
  VAR e,e2: SHORTCARD;
  BEGIN
    Eths:=bd.nEth;
    FOR e:=1 TO Eths DO
      Nn[e]:=LongType(bd.UV(1,e));
      n0[e]:=LongType(bd.UV(2,e));

      KPii[e]:=LongType(bd.VK(1,e));
      KPpp[e]:=LongType(bd.VK(2,e));
      KPpm[e]:=LongType(bd.VK(3,e));
      KPm [e]:=LongType(bd.VK(4,e));
      KPsp[e]:=LongType(bd.VK(5,e));
      KPo [e]:=LongType(bd.VK(6,e));
      FOR e2:=1 TO Eths DO
        KPw[e,e2]:=LongType(bd.MK(1,e,e2));
      END;

      KPl [e]:=LongType(bd.VK(7,e));
      KPc [e]:=LongType(bd.VK(8,e));
      FOR e2:=1 TO Eths DO
        KPt[e,e2]:=LongType(bd.MK(2,e,e2));
      END;

      KSii[e]:=LongType(bd.VK(9,e));
      FOR e2:=1 TO Eths DO
        KSw[e,e2]:=LongType(bd.MK(3,e,e2));
      END;

      KMii[e]:=LongType(bd.VK(10,e));
      FOR e2:=1 TO Eths DO
        KMt[e,e2]:=LongType(bd.MK(4,e,e2));
        KMc[e,e2]:=LongType(bd.MK(5,e,e2));
        KMw[e,e2]:=LongType(bd.MK(6,e,e2));
      END;

      KMo [e]:=LongType(bd.VK(11,e));
      KMl [e]:=LongType(bd.VK(12,e));
      KMp [e]:=LongType(bd.VK(13,e));

      FOR e2:=1 TO Eths DO
        KOwop[e,e2]:=LongType(bd.MK(7,e,e2));
        KOwom[e,e2]:=LongType(bd.MK(8,e,e2));
      END;
      KOm [e]:=LongType(bd.VK(14,e));
      KOt1[e]:=LongType(bd.VK(15,e));
      KOt2[e]:=LongType(bd.VK(16,e));
      KOc1[e]:=LongType(bd.VK(17,e));
      KOc2[e]:=LongType(bd.VK(18,e));

      FOR e2:=1 TO Eths DO
        KCc[e,e2]:=LongType(bd.MK(9,e,e2));
      END;

      KLo [e]:=LongType(bd.VK(19,e));
      KLc [e]:=LongType(bd.VK(20,e));
    END;
  END ConvertEthnos;

PROCEDURE ddP(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                               (*ᨮਨ*)

VAR Pii,Ppp,Pm,Psp,Po,Pw,Pe,Ppm,Psm,Pl,Pc,Pt,Pmp:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Pii:=KPii[i]*Imp(i,t);                  (*ᨮ ⮫箪*)
  Ppp:=KPpp[i]*Xi(P)*P;                   (* ᨮਥ*)
  Ppm:=KPpm[i]*P*P;                       (*ॡ*)

  Pm :=KPm [i]*Xi(dP)*M;                  (*প த*)
  Psp:=KPsp[i]*Sign(dP)*S;                (*ﭨ 㡯ᨮਥ*)
  Po :=KPo [i]*Xi(P)*P;    (*Xi(KPo[i])*) (* ࣠樨*)
  Pw:=0.;
  FOR j:=1 TO Eths DO
     Pw:=Pw+KPw[i,j]*War(i,j,t)           (*  *)
  END;
  Pw:=Pw*P;
  Pe:=KPe[i]*Dict(i)*P;                   (* ??? *)
  Pl:=KPl[i]*P;                           (*८ࠧ *)
  Pt:=0.;
  FOR j:=1 TO Eths DO
    Pt:=Pt+KPt[i,j];                      (*孨᪮  筮 ⢮⢮*)
  END;
  Pt:=Pt*P;
  Pc:=KPc[i]*P;                           (*୮ ⢮⢮*)

  RETURN(Pii+Ppp+Pm-Psp-Po-Pw-Pe-Ppm-Pl-Pc-Pt);
END ddP;

PROCEDURE ddM(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                         (*ମ  ()*)

VAR Mii,Mtc,Mp,Mw,Mo,Ml,Mpp:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Mii:=KMii[i]*Imp(i,t);                   (*箪 த*)
  Mtc:=0.;
  FOR j:=1 TO Eths DO                      (*祭  ਢ த*)
      Mtc:=Mtc+KMt[i,j]*X^[4*Eths+j]+KMc[i,j]*X^[5*Eths+j]
  END;
  Mp:=KPm[i]*Xi(dP)*M;                     (*প த ᨮਥ*)
  Mo:=KMo[i]*M;                            (*  ࣠*)
                (*Xi(O0[i]-O)*)
  Mw:=0.;
  FOR j:=1 TO Eths DO
     Mw:=Mw+KMw[i,j]*War(i,j,t)            (*  *)
  END;
  Mw:=Mw*M;
  Ml:=KMl[i]*M;                            (*  *)

  RETURN(Mii+Mtc-Mp-Mw-Mo-Ml);
END ddM;

PROCEDURE ddS(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                              (*㡯ᨮਨ*)

VAR Sii,Sp,Sw,Som,Sot,Soc:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Sii:=KSii[i]*Imp(i,t);                   (*箪 㡯ᨨਥ*)
  Sp:=KPsp[i]*Sign(dP)*S;                  (*⢨  ᨮﬨ*)
  Sw:=0.;
  FOR j:=1 TO Eths DO
     Sw:=Sw+KSw[i,j]*War(i,j,t)            (*  *)
  END;
  Sw:=Sw*S;

  RETURN(Sii+Sp-Sw);
END ddS;

PROCEDURE ddO(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                     (*࣠ (㤠⢮)*)

VAR Op,Omp,Owp,Owm,Owop,Ol,Owom,Omm,Ot1,Oc1,Ot2,Oc2:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Op:=KPo[i]*Xi(P)*P;                      (*ﭨ ᨮਥ*)
  Omp:=KMo[i]*M;                           (*প த*)
             (*Xi(O0[i]-O)*)
  Owp:=0.; Owm:=0.; Owop:=0.; Owom:=0.;
  FOR j:=1 TO Eths DO                      (* *)
      Owp:=Owp+KPw[i,j]*War(i,j,t);
      Owm:=Owm+(KSw[i,j]*X^[2*Eths+j]+KMw[i,j]*X^[Eths+j])*War(i,j,t);
      Owop:=Owop+KOwop[i,j]*Xi(M-X^[Eths+j])*Xi(P-X^[j])
           *Xi(O-X^[3*Eths+j])*Xi(T-X^[4*Eths+j])
           *X^[3*Eths+j]*War(i,j,t);
      Owom:=Owom+KOwom[i,j]*Xi(X^[Eths+j]-M)*Xi(X^[j]-P)
           *Xi(X^[3*Eths+j]-O)*Xi(X^[4*Eths+j]-T)
           *O*War(i,j,t);
  END;
  Owp:=Owp*P(*O*);
  (*Owm:=Owm*O;*)
  (*Omm:=KOm[i]*Xi(O-O1[i])*O;*)           (* ??? 樨*)

  Ol:=KLo[i]*L;                            (*ﭨ *)
  Ot1:=KOt1[i]*O;                          (*  প 㪨*)
                   (*Xi(O-O1[i])*)
  Ot2:=KOt2[i]*Dict(i)*O;                  (*   㪨*)
  Oc1:=KOc1[i]*O;                          (*  প *)
  Oc2:=KOc2[i]*Dict(i)*O;                  (*   *)

  RETURN(Op+Omp+Owp+Owm+Owop+Ol-Owom-Ot1-Oc1-Ot2-Oc2);
END ddO;

PROCEDURE ddT(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                          (*㪠  孨*)

VAR Tp,Top,Tom,Tm:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Tp:=0.; Tm:=0.;
  FOR j:=1 TO Eths DO
      Tp:=Tp+KPt[j,i]*Xi(X^[j])*X^[j];    (* ᨮਥ*)
      Tm:=Tm+KMt[i,j];
  END;
  Tm:=Tm*T;                               (*祭 த*)
  Top:=KOt1[i]*O;                         (*প ࣠樥*)
                (*Xi(O-O1[i])*)
  Tom:=KOt2[i]*Dict(i)*O;                 (* ࣠樥*)

  RETURN(Tp+Top-Tom-Tm);
END ddT;

PROCEDURE ddC(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                           (*  ⢮*)

VAR Cp,Ccp,Ccm,Cop,Cl,Com,Cm:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Cp:=KPc[i]*Xi(P)*P;                     (* ᨮਥ*)
  Ccp:=0.; Ccm:=0.; Cm:=0.;
  FOR j:=1 TO Eths DO
   Ccm:=Ccm+KCc[i,j];                     (*⤠ 㣨 *)
   Ccp:=Ccp+KCc[j,i]*X^[5*Eths+j];
   Cm:=Cm+KMc[i,j];
  END;
  Ccm:=Ccm*C;
  (*Ccp:=Ccp*(1.-Xi(dP));*)               (*⢮ 㣨 *)
                   (*Xi(P-P0[i])*)
  Cm:=Cm*C;                               (*ﭨ   த*)
  Cop:=KOc1[i]*O;                         (*প ࣠樥*)
  Com:=KOc2[i]*Dict(i)*O;                 (* ࣠樥*)
  Cl:=KLc[i]*L;                           (*ﭨ *)

  RETURN(Cp+Ccp+Cop+Cl-Com-Cm-Ccm);
END ddC;

PROCEDURE ddL(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;

                               (**)

VAR Lp,Lm,Lo,Lc:LongType;
    j:SHORTCARD;
    P,M,S,O,T,C,L,dP: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i];
  T:=X^[4*Eths+i]; C:=X^[5*Eths+i]; L:=X^[6*Eths+i];
  dP:=dX^[i];

  Lp:=KPl[i]*Xi(P)*P;                     (* ᨮਥ*)
  Lm:=KMl[i]*Xi(M)*M;                     (* த*)
(*  Lo:=KLo[i]*O;
  Lc:=KLc[i]*C;*)
  Lo:=KLo[i]*L;                           (*প ࣠樨*)
  Lc:=KLc[i]*L;                           (*প *)

  RETURN(Lp+Lm-Lo-Lc);
END ddL;

PROCEDURE PasNap(i: SHORTCARD; t: TypeData; VAR ed: EDEth): TypeData;
BEGIN
  IF Nn[i]*LongType(t)+n0[i]#0. THEN
    RETURN((ed.VP(1,i,t)+ed.VP(2,i,t)+ed.VP(3,i,t))/TypeData(Nn[i]*LongType(t)+n0[i]));
  ELSE
    RETURN(0.)
  END
END PasNap;

PROCEDURE PasNapL(i: SHORTCARD; t: LongType; X: PVectL): LongType;
BEGIN
  IF Nn[i]*t+n0[i]#0. THEN
    RETURN((X^[i]+X^[Eths+i]+X^[2*Eths+i])/(Nn[i]*t+n0[i]));
  ELSE
    RETURN(0.)
  END
END PasNapL;

VAR
  F0,dF,f0,H0,dH,h0,Kj0,mu0,dmu,V0,dV,vi0,dvi,
  Kkp,Kko,Kkg,Kkf,Kkh,KkG,Kkk,Kkl,
  Klo,Klg,Klc,Klp,Klms1,Klms2,Klm,
  Kek,Kemu,Keg,Kekp,
  Kgpm1,Kgpm2,Kge,Kgp,Kgkl1,Kgkl2,Kgem: ArrLT;
  Kev,Kevi,Ket: ArrALT;

  PROCEDURE ConvertEthSoc(bd: BDEth);
  VAR e,e2: SHORTCARD;
  BEGIN
    Eths:=bd.nEth;
    FOR e:=1 TO Eths DO
      Nn [e]:=LongType(bd.UV(1,e));
      n0 [e]:=LongType(bd.UV(2,e));
      F0 [e]:=LongType(bd.UV(3,e));
      dF [e]:=LongType(bd.UV(4,e));
      f0 [e]:=LongType(bd.UV(5,e));
      H0 [e]:=LongType(bd.UV(6,e));
      dH [e]:=LongType(bd.UV(7,e));
      h0 [e]:=LongType(bd.UV(8,e));
      Kj0[e]:=LongType(bd.UV(9,e));
      mu0[e]:=LongType(bd.UV(10,e));
      dmu[e]:=LongType(bd.UV(11,e));
      V0 [e]:=LongType(bd.UV(12,e));
      dV [e]:=LongType(bd.UV(13,e));
      vi0[e]:=LongType(bd.UV(14,e));
      dvi[e]:=LongType(bd.UV(15,e));

      KPii[e]:=LongType(bd.VK(1,e));
      KPpp[e]:=LongType(bd.VK(2,e));
      KPpm[e]:=LongType(bd.VK(3,e));
      KPm [e]:=LongType(bd.VK(4,e));
      KPsp[e]:=LongType(bd.VK(5,e));
      KPo [e]:=LongType(bd.VK(6,e));
      FOR e2:=1 TO Eths DO
        KPw[e,e2]:=LongType(bd.MK(1,e,e2));
      END;

      KPl [e]:=LongType(bd.VK(7,e));
      KPc [e]:=LongType(bd.VK(8,e));
      FOR e2:=1 TO Eths DO
        KPt[e,e2]:=LongType(bd.MK(2,e,e2));
      END;

      KSii[e]:=LongType(bd.VK(9,e));
      FOR e2:=1 TO Eths DO
        KSw[e,e2]:=LongType(bd.MK(3,e,e2));
      END;

      KMii[e]:=LongType(bd.VK(10,e));
      FOR e2:=1 TO Eths DO
        KMt[e,e2]:=LongType(bd.MK(4,e,e2));
        KMc[e,e2]:=LongType(bd.MK(5,e,e2));
        KMw[e,e2]:=LongType(bd.MK(6,e,e2));
      END;

      KMo [e]:=LongType(bd.VK(11,e));
      KMl [e]:=LongType(bd.VK(12,e));
      KMp [e]:=LongType(bd.VK(13,e));

      FOR e2:=1 TO Eths DO
        KOwop[e,e2]:=LongType(bd.MK(7,e,e2));
        KOwom[e,e2]:=LongType(bd.MK(8,e,e2));
      END;
      KOm [e]:=LongType(bd.VK(14,e));
      KOt1[e]:=LongType(bd.VK(15,e));
      KOt2[e]:=LongType(bd.VK(16,e));
      KOc1[e]:=LongType(bd.VK(17,e));
      KOc2[e]:=LongType(bd.VK(18,e));

      FOR e2:=1 TO Eths DO
        KCc[e,e2]:=LongType(bd.MK(9,e,e2));
      END;

      KLo [e]:=LongType(bd.VK(19,e));
      KLc [e]:=LongType(bd.VK(20,e));

      Kkp  [e]:=LongType(bd.VK(21,e));
      Kko  [e]:=LongType(bd.VK(22,e));
      Kkg  [e]:=LongType(bd.VK(23,e));
      Kkf  [e]:=LongType(bd.VK(24,e));
      Kkh  [e]:=LongType(bd.VK(25,e));
      KkG  [e]:=LongType(bd.VK(26,e));
      Kkk  [e]:=LongType(bd.VK(27,e));
      Kkl  [e]:=LongType(bd.VK(28,e));
      Klo  [e]:=LongType(bd.VK(29,e));
      Klg  [e]:=LongType(bd.VK(30,e));
      Klc  [e]:=LongType(bd.VK(31,e));
      Klp  [e]:=LongType(bd.VK(32,e));
      Klms1[e]:=LongType(bd.VK(33,e));
      Klms2[e]:=LongType(bd.VK(34,e));
      Klm  [e]:=LongType(bd.VK(35,e));
      Kek  [e]:=LongType(bd.VK(36,e));
      Kemu [e]:=LongType(bd.VK(37,e));
      Keg  [e]:=LongType(bd.VK(38,e));
      Kekp [e]:=LongType(bd.VK(39,e));
      Kgpm1[e]:=LongType(bd.VK(40,e));
      Kgpm2[e]:=LongType(bd.VK(41,e));
      Kge  [e]:=LongType(bd.VK(42,e));
      Kgp  [e]:=LongType(bd.VK(43,e));
      Kgkl1[e]:=LongType(bd.VK(44,e));
      Kgkl2[e]:=LongType(bd.VK(45,e));
      Kgem [e]:=LongType(bd.VK(46,e));

      FOR e2:=1 TO Eths DO
        Kev [e,e2]:=LongType(bd.MK(10,e,e2));
        Kevi[e,e2]:=LongType(bd.MK(11,e,e2));
        Ket [e,e2]:=LongType(bd.MK(12,e,e2));
      END;
    END;
  END ConvertEthSoc;


PROCEDURE ddK(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR P,M,S,O,T,K,l,e,g,dO,dC,dK,dl,de,dg: LongType;
      Kp,Ko,Kg,Kf,Kh,KG,Kj,Kl: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i]; T:=X^[4*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];
  dO:=dX^[3*Eths+i]; dC:=dX^[5*Eths+i];
  dK:=dX^[7*Eths+i]; dl:=dX^[8*Eths+i]; de:=dX^[9*Eths+i]; dg:=dX^[10*Eths+i];

  Kp:=Kkp[i]*PasNapL(i,t,X);
  Ko:=Kko[i]*Sign(dO*dK)*O;
  Kg:=Kkg[i]*g;
  Kf:=Kkf[i]*(F0[i]+dF[i]*t)*Sign((F0[i]+dF[i]*t)/((n0[i]+Nn[i]*t)-f0[i]));
  Kh:=Kkh[i]*(H0[i]+dH[i]*t)*Sign((H0[i]+dH[i]*t)/((n0[i]+Nn[i]*t)-h0[i]));
  KG:=KkG[i]*(n0[i]+Nn[i]*t);
  Kj:=Kkk[i]*Kj0[i];
  Kl:=Kkl[i]*l;
  RETURN(Kp+Ko+Kg+Kf+Kh-KG-Kj-Kl);
END ddK;

PROCEDURE ddl(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR P,M,S,O,T,K,l,e,g,dO,dC,dK,dl,de,dg: LongType;
      lo,lg,lc,lp,lms,lm: LongType;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i]; T:=X^[4*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];
  dO:=dX^[3*Eths+i]; dC:=dX^[5*Eths+i];
  dK:=dX^[7*Eths+i]; dl:=dX^[8*Eths+i]; de:=dX^[9*Eths+i]; dg:=dX^[10*Eths+i];

  lo:=Klo[i]*O;
  lg:=Klg[i]*g;
  lc:=Klc[i]*Sign(dC*dl)*O;
  lp:=Klp[i]*P;
  lms:=Klms1[i]*M+Klms2[i]*S;
  lm:=Klm[i]*M;
  RETURN(lo+lg+lc-lp-lms-lm);
END ddl;

PROCEDURE dde(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR P,M,S,O,T,K,l,e,g,dO,dC,dK,dl,de,dg: LongType;
      ek,emu,ev,evi,et,eg,ekp: LongType;
      j: SHORTCARD;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i]; T:=X^[4*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];
  dO:=dX^[3*Eths+i]; dC:=dX^[5*Eths+i];
  dK:=dX^[7*Eths+i]; dl:=dX^[8*Eths+i]; de:=dX^[9*Eths+i]; dg:=dX^[10*Eths+i];

  ek:=Kek[i]*K;
  emu:=Kemu[i]*(mu0[i]-dmu[i]*t);
  ev:=0.; evi:=0.; et:=0.;
  FOR j:=1 TO Eths DO
    ev:=ev+Kev[i,j]*(V0[j]+dV[j]*t);
    evi:=evi+Kevi[i,j]*(vi0[j]+dvi[j]*t);
    et:=et+Ket[i,j]*X^[4*Eths+j];
  END;
  eg:=Keg[i]*Sign(de*dg)*g;
  ekp:=Kekp[i]*Sign(de*dK)*K;
  RETURN(ek+emu+ev+evi+et+eg+ekp);
END dde;

PROCEDURE ddg(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR P,M,S,O,T,K,l,e,g,dO,dC,dK,dl,de,dg: LongType;
      gpm,ge,gp,li,gkl,gk,gl,gem: LongType;
      j: SHORTCARD;
BEGIN
  P:=X^[i]; M:=X^[Eths+i]; S:=X^[2*Eths+i]; O:=X^[3*Eths+i]; T:=X^[4*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];
  dO:=dX^[3*Eths+i]; dC:=dX^[5*Eths+i];
  dK:=dX^[7*Eths+i]; dl:=dX^[8*Eths+i]; de:=dX^[9*Eths+i]; dg:=dX^[10*Eths+i];

  gpm:=Kgpm1[i]*P+Kgpm2[i]*M;
  ge:=Kge[i]*e;
  gp:=Kgp[i]*Sign(de)*P;
  li:=0.5*(Sign(dK*dg)+Sign(dl*dg));
  gkl:=(Kgkl1[i]*K+Kgkl2[i]*l)*li;
  gk:=Kkg[i]*g;
  gl:=Klg[i]*g;
  gem:=Kgem[i]*g;
  RETURN(gpm+ge+gp+gkl-gk-gl-gem);
END ddg;

VAR
  K0,l0,O0,
  kkp,kko,kkg,kkl,
  klo,klg,kll,
  kee,keg,kel,
  kge,kgg,kgo,
  eps,eps1,beta,beta1,alf,alf1: ArrLT;

  PROCEDURE ConvertLSoc(bd: BDEth);
  VAR e,e2: SHORTCARD;
  BEGIN
    Eths:=bd.nEth;
    FOR e:=1 TO Eths DO
      Nn [e]:=LongType(bd.UV(1,e));
      n0 [e]:=LongType(bd.UV(2,e));
      K0 [e]:=LongType(bd.UV(3,e));
      l0 [e]:=LongType(bd.UV(4,e));
      O0 [e]:=LongType(bd.UV(5,e));

      KPii[e]:=LongType(bd.VK(1,e));
      KPpp[e]:=LongType(bd.VK(2,e));
      KPpm[e]:=LongType(bd.VK(3,e));
      KPm [e]:=LongType(bd.VK(4,e));
      KPsp[e]:=LongType(bd.VK(5,e));
      KPo [e]:=LongType(bd.VK(6,e));
      FOR e2:=1 TO Eths DO
        KPw[e,e2]:=LongType(bd.MK(1,e,e2));
      END;

      KPl [e]:=LongType(bd.VK(7,e));
      KPc [e]:=LongType(bd.VK(8,e));
      FOR e2:=1 TO Eths DO
        KPt[e,e2]:=LongType(bd.MK(2,e,e2));
      END;

      KSii[e]:=LongType(bd.VK(9,e));
      FOR e2:=1 TO Eths DO
        KSw[e,e2]:=LongType(bd.MK(3,e,e2));
      END;

      KMii[e]:=LongType(bd.VK(10,e));
      FOR e2:=1 TO Eths DO
        KMt[e,e2]:=LongType(bd.MK(4,e,e2));
        KMc[e,e2]:=LongType(bd.MK(5,e,e2));
        KMw[e,e2]:=LongType(bd.MK(6,e,e2));
      END;

      KMo [e]:=LongType(bd.VK(11,e));
      KMl [e]:=LongType(bd.VK(12,e));
      KMp [e]:=LongType(bd.VK(13,e));

      FOR e2:=1 TO Eths DO
        KOwop[e,e2]:=LongType(bd.MK(7,e,e2));
        KOwom[e,e2]:=LongType(bd.MK(8,e,e2));
      END;
      KOm [e]:=LongType(bd.VK(14,e));
      KOt1[e]:=LongType(bd.VK(15,e));
      KOt2[e]:=LongType(bd.VK(16,e));
      KOc1[e]:=LongType(bd.VK(17,e));
      KOc2[e]:=LongType(bd.VK(18,e));

      FOR e2:=1 TO Eths DO
        KCc[e,e2]:=LongType(bd.MK(9,e,e2));
      END;

      KLo [e]:=LongType(bd.VK(19,e));
      KLc [e]:=LongType(bd.VK(20,e));

      kkp  [e]:=LongType(bd.VK(21,e));
      kko  [e]:=LongType(bd.VK(22,e));
      kkg  [e]:=LongType(bd.VK(23,e));
      kkl  [e]:=LongType(bd.VK(24,e));
      klo  [e]:=LongType(bd.VK(25,e));
      klg  [e]:=LongType(bd.VK(26,e));
      kll  [e]:=LongType(bd.VK(27,e));
      kee  [e]:=LongType(bd.VK(28,e));
      keg  [e]:=LongType(bd.VK(29,e));
      kel  [e]:=LongType(bd.VK(30,e));
      kge  [e]:=LongType(bd.VK(31,e));
      kgg  [e]:=LongType(bd.VK(32,e));
      kgo  [e]:=LongType(bd.VK(33,e));
      eps  [e]:=LongType(bd.VK(34,e));
      eps1 [e]:=LongType(bd.VK(35,e));
      beta [e]:=LongType(bd.VK(36,e));
      beta1[e]:=LongType(bd.VK(37,e));
      alf  [e]:=LongType(bd.VK(38,e));
      alf1 [e]:=LongType(bd.VK(39,e));
    END;
  END ConvertLSoc;


PROCEDURE LddK(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR O,K,l,e,g: LongType;
      Ko,Kg,Kl,Kp: LongType;
BEGIN
  O:=X^[3*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];

  Kp:=kkp[i]*PasNapL(i,t,X);
  Ko:=kko[i]*(K*K-K0[i])*O;
  Kg:=kkg[i]*g*g;
  Kl:=kkl[i]*l;
  RETURN(Ko+Kg-Kl+Kp);
END LddK;

PROCEDURE Lddl(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR O,K,l,e,g: LongType;
      lo,lg,ll: LongType;
BEGIN
  O:=X^[3*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];

  lo:=klo[i]*O;
  lg:=klg[i]*g*g;
  ll:=kll[i]*(l*l-l0[i])*O;
  RETURN(lo+lg+ll);
END Lddl;

PROCEDURE Ldde(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR O,K,l,e,g: LongType;
      ee,eg,el: LongType;
BEGIN
  O:=X^[3*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];

  ee:=kee[i]*(Exp(eps[i]*O+eps1[i])-1.0)*e;
  eg:=keg[i]*Exp(-beta[i]*O+beta1[i])*g;
  el:=kel[i]*Exp(-alf[i]*e+alf1[i])*l;
  RETURN(ee-eg-el);
END Ldde;

PROCEDURE Lddg(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
  VAR O,K,l,e,g: LongType;
      ge,gg,go: LongType;
BEGIN
  O:=X^[3*Eths+i];
  K:=X^[7*Eths+i]; l:=X^[8*Eths+i]; e:=X^[9*Eths+i]; g:=X^[10*Eths+i];

  ge:=kge[i]*Exp(-beta[i]*O+beta1[i])*e;
  gg:=kgg[i]*(Exp(eps[i]*O+eps1[i])-1.0)*g;
  go:=kgo[i]*(O*O-O0[i])*(K*K+l*l);
  RETURN(ge+gg+go);
END Lddg;

PROCEDURE ConvertExample(bd: BDEth);
BEGIN
END ConvertExample;

PROCEDURE ddX(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(-X^[1]+X^[2]+X^[3]);
END ddX;

PROCEDURE ddY(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(X^[1]-X^[2]+X^[3]);
END ddY;

PROCEDURE ddZ(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(X^[1]+X^[2]-X^[3]);
END ddZ;

VAR
  kk,ek,alp,bet,C1,C2,C3,C4: LongType;

PROCEDURE ConvertSocio(bd: BDEth);
BEGIN
  kk:=LongType(bd.VK(1,1)); ek:=Exp(kk);
  alp:=LongType(bd.VK(2,1));
  bet:=LongType(bd.VK(3,1));
  C1:=LongType(bd.VK(4,1));
  C2:=LongType(bd.VK(5,1));
  C3:=LongType(bd.VK(6,1));
  C4:=LongType(bd.VK(7,1));
END ConvertSocio;

PROCEDURE dEconomy(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(C1*(ek-Exp(-alp*X^[1]))*X^[1]-C2*Exp(-bet*X^[2])*X^[2]);
(*  RETURN(-C2*X^[2]);*)
END dEconomy;

PROCEDURE dPoliticy(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(C3*(ek-1.)*X^[2]+C4*ek*X^[1]);
(*  RETURN(C3*Sin(C1*t)*X^[2]+C4*X^[1]);*)
END dPoliticy;

VAR kPass,kPS,kPB,kPT,kP,kPE,kE,kEP,kPPs: LongType;
PROCEDURE ConvertVic(bd: BDEth);
BEGIN
  kPass:=LongType(bd.VK(1,1));
  kPS:=LongType(bd.VK(2,1));
  kPB:=LongType(bd.VK(3,1));
  kPT:=LongType(bd.VK(4,1));
  kPE:=LongType(bd.VK(5,1));
  kE :=LongType(bd.VK(6,1));
  kEP:=LongType(bd.VK(7,1));
  kPPs:=LongType(bd.VK(8,1));
END ConvertVic;

PROCEDURE dPass(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN((kPass*(1.-X^[1])-kPPs*ABS(X^[2]))*X^[1]);
END dPass;

PROCEDURE dPol(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN((kPS*dX^[1]+kPE*X^[3])*X^[1]);
END dPol;

PROCEDURE dEco(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN((kE*X^[3]-kEP*X^[2])*X^[1]);
END dEco;

PROCEDURE dBio(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(kPB*dX^[1]);
END dBio;

PROCEDURE dTech(i:SHORTCARD; t: LongType; X,dX: PVectL):LongType;
BEGIN
  RETURN(kPT*dX^[1]);
END dTech;


PROCEDURE ConvertData(bd: BDEth);
BEGIN
  CASE bd.TypeSystem OF
  | 1: ConvertEthnos(bd);
  | 2: ConvertExample(bd);
  | 3: ConvertSocio(bd);
  | 4: ConvertVic(bd);
  | 5: ConvertEthSoc(bd);
  | 6: ConvertLSoc(bd);
  END;
END ConvertData;

PROCEDURE Function(ts,i: SHORTCARD): Func;
BEGIN
  CASE ts OF
  | 1:
    CASE i OF
     | 1: RETURN(ddP);
     | 2: RETURN(ddM);
     | 3: RETURN(ddS);
     | 4: RETURN(ddO);
     | 5: RETURN(ddT);
     | 6: RETURN(ddC);
     | 7: RETURN(ddL);
     END;
  | 2:
    CASE i OF
    | 1: RETURN(ddX);
    | 2: RETURN(ddY);
    | 3: RETURN(ddZ);
    END;
  | 3:
    CASE i OF
    | 1: RETURN(dEconomy);
    | 2: RETURN(dPoliticy);
    END;
  | 4:
    CASE i OF
    | 1: RETURN(dPass);
    | 2: RETURN(dPol);
    | 3: RETURN(dEco);
    | 4: RETURN(dBio);
    | 5: RETURN(dTech);
    END;
  | 5:
    CASE i OF
     | 1: RETURN(ddP);
     | 2: RETURN(ddM);
     | 3: RETURN(ddS);
     | 4: RETURN(ddO);
     | 5: RETURN(ddT);
     | 6: RETURN(ddC);
     | 7: RETURN(ddL);
     | 8: RETURN(ddK);
     | 9: RETURN(ddl);
     |10: RETURN(dde);
     |11: RETURN(ddg);
     END;
  | 6:
    CASE i OF
     | 1: RETURN(ddP);
     | 2: RETURN(ddM);
     | 3: RETURN(ddS);
     | 4: RETURN(ddO);
     | 5: RETURN(ddT);
     | 6: RETURN(ddC);
     | 7: RETURN(ddL);
     | 8: RETURN(LddK);
     | 9: RETURN(Lddl);
     |10: RETURN(Ldde);
     |11: RETURN(Lddg);
     END;
  END;
END Function;

BEGIN
END Urs.
